123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104 |
- builtin which py > /dev/null || alias py='python3'
- alias pyfind='find . -name "*.py"'
- function pyclean() {
- find "${@:-.}" -type f -name "*.py[co]" -delete
- find "${@:-.}" -type d -name "__pycache__" -delete
- find "${@:-.}" -depth -type d -name ".mypy_cache" -exec rm -r "{}" +
- find "${@:-.}" -depth -type d -name ".pytest_cache" -exec rm -r "{}" +
- }
- function pyuserpaths() {
- setopt localoptions extendedglob
-
- local user_base="${PYTHONUSERBASE:-"${HOME}/.local"}"
- local python version site_pkgs
- for python in python2 python3; do
- # Check if command exists
- (( ${+commands[$python]} )) || continue
- # Get minor release version.
- # The patch version is variable length, truncate it.
- version=${(M)${"$($python -V 2>&1)":7}#[^.]##.[^.]##}
- # Add version specific path, if:
- # - it exists in the filesystem
- # - it isn't in $PYTHONPATH already.
- site_pkgs="${user_base}/lib/python${version}/site-packages"
- [[ -d "$site_pkgs" && ! "$PYTHONPATH" =~ (^|:)"$site_pkgs"(:|$) ]] || continue
- export PYTHONPATH="${site_pkgs}${PYTHONPATH+":${PYTHONPATH}"}"
- done
- }
- alias pygrep='grep -nr --include="*.py"'
- alias pyserver="python3 -m http.server"
- : ${PYTHON_VENV_NAME:=venv}
- function vrun() {
- local name="${1:-$PYTHON_VENV_NAME}"
- local venvpath="${name:P}"
- if [[ ! -d "$venvpath" ]]; then
- echo >&2 "Error: no such venv in current directory: $name"
- return 1
- fi
- if [[ ! -f "${venvpath}/bin/activate" ]]; then
- echo >&2 "Error: '${name}' is not a proper virtual environment"
- return 1
- fi
- . "${venvpath}/bin/activate" || return $?
- echo "Activated virtual environment ${name}"
- }
- function mkv() {
- local name="${1:-$PYTHON_VENV_NAME}"
- local venvpath="${name:P}"
- python3 -m venv "${name}" || return
- echo >&2 "Created venv in '${venvpath}'"
- vrun "${name}"
- }
- if [[ "$PYTHON_AUTO_VRUN" == "true" ]]; then
-
- function auto_vrun() {
-
-
- if (( $+functions[deactivate] )) && [[ $PWD != ${VIRTUAL_ENV:h}* ]]; then
- deactivate > /dev/null 2>&1
- fi
- if [[ $PWD != ${VIRTUAL_ENV:h} ]]; then
- for _file in "${PYTHON_VENV_NAME}"*/bin/activate(N.); do
-
- (( $+functions[deactivate] )) && deactivate > /dev/null 2>&1
- source $_file > /dev/null 2>&1
- break
- done
- fi
- }
- add-zsh-hook chpwd auto_vrun
- auto_vrun
- fi
|